"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var pango_1 = require("pango");
var path = require("path");
var GccOptions_1 = require("./GccOptions");
var fs = require("fs-extra");
var GccCompileFileTarget = /** @class */ (function () {
    function GccCompileFileTarget(fileName) {
        this.preRequisites = ['generate-sources'];
        this.postRequisites = ['compile'];
        if (!fileName) {
            throw new Error("fileName is required");
        }
        if (typeof fileName === 'string') {
            this._fileName = fileName;
        }
        else {
            var fileInfo = fileName;
            this._fileName = fileInfo.fileName;
            this._outputPath = fileInfo.outputPath;
            this._depPath = fileInfo.depPath;
        }
    }
    GccCompileFileTarget.prototype.run = function (projectOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var options, filePathWithoutExt, relativePath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = GccOptions_1.getGccOptions(projectOptions);
                        filePathWithoutExt = path.basename(this._fileName, path.extname(this._fileName));
                        if (!projectOptions.buildDir) {
                            throw new Error("Missing \"buildDir\" configuration.");
                        }
                        relativePath = path.dirname(path.relative(projectOptions.projectDir, this._fileName));
                        this._outputPath = this._outputPath || path.join(projectOptions.buildDir, relativePath, filePathWithoutExt) + '.o';
                        this._depPath = this._depPath || path.join(projectOptions.buildDir, relativePath, filePathWithoutExt) + '.d';
                        return [4 /*yield*/, this.shouldExecute(projectOptions)];
                    case 1:
                        if (!_a.sent()) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.compileAndDeps(projectOptions, options)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        options.allObjectFiles.push(this._outputPath);
                        return [2 /*return*/];
                }
            });
        });
    };
    GccCompileFileTarget.prototype.shouldExecute = function (projectOptions) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, pango_1.FileUtils.isOutputFileOlderThenInputFiles(this._outputPath, this.getInputFiles())];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    GccCompileFileTarget.prototype.getInputFiles = function () {
        return __awaiter(this, void 0, void 0, function () {
            var exists, depContents, depLines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._fileName.match(/\.s|\.S$/)) {
                            return [2 /*return*/, [this._fileName]];
                        }
                        return [4 /*yield*/, fs.pathExists(this._depPath)];
                    case 1:
                        exists = _a.sent();
                        if (!exists) {
                            return [2 /*return*/, []];
                        }
                        return [4 /*yield*/, fs.readFile(this._depPath, 'utf8')];
                    case 2:
                        depContents = _a.sent();
                        depLines = depContents.trim().split('\n')
                            .map(function (line) { return line.replace(/\\$/, '').trim(); });
                        depLines[0] = depLines[0].replace(/.*?:/, '').trim();
                        return [2 /*return*/, depLines.filter(function (dep) {
                                return dep && dep.length > 0;
                            })];
                }
            });
        });
    };
    GccCompileFileTarget.prototype.compileAndDeps = function (projectOptions, options) {
        return __awaiter(this, void 0, void 0, function () {
            var ext, compiler, compilerOptions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ext = path.extname(this._fileName).toLowerCase();
                        compiler = options.compilers[ext];
                        if (!compiler) {
                            throw new Error("Could not find compiler for extension " + ext);
                        }
                        compilerOptions = this.getCompilerOptions(projectOptions, options);
                        return [4 /*yield*/, fs.mkdirs(path.dirname(this._outputPath))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.compile(projectOptions, compiler, compilerOptions)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.createDeps(projectOptions, compiler, compilerOptions)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    GccCompileFileTarget.prototype.compile = function (projectOptions, compiler, compilerOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = [compiler, '-c']
                            .concat(compilerOptions)
                            .concat(['-o', this._outputPath]);
                        projectOptions.logger.info(cmd.join(' '));
                        return [4 /*yield*/, pango_1.Shell.shell(projectOptions, cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    GccCompileFileTarget.prototype.createDeps = function (projectOptions, compiler, compilerOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                cmd = [compiler, '-MM']
                    .concat(compilerOptions)
                    .concat(['-o', this._depPath]);
                return [2 /*return*/, pango_1.Shell.shell(projectOptions, cmd)];
            });
        });
    };
    GccCompileFileTarget.prototype.getCompilerOptions = function (projectOptions, options) {
        var results = [];
        results = results.concat(projectOptions.compilerOptions || []);
        results = results.concat(options.compilerOptions || []);
        results = results.concat(this.getIncludeDirs(projectOptions, options).reduce(function (all, s) {
            return all.concat(['-I', s]);
        }, []));
        results = results.concat([this._fileName]);
        return results;
    };
    GccCompileFileTarget.prototype.getIncludeDirs = function (projectOptions, options) {
        return (projectOptions.includeDirs || []).concat(options.includeDirs || []);
    };
    return GccCompileFileTarget;
}());
exports.GccCompileFileTarget = GccCompileFileTarget;
//# sourceMappingURL=GccCompileFileTarget.js.map